﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Net;
using System.IO;
using System.Text;

using Hidistro.Entities.Sales;
using Hidistro.AccountCenter.Business;

public partial class _Default : System.Web.UI.Page
{

    //电商ID
    private string EBusinessID = "******";
    //电商加密私钥，快递鸟提供，注意保管，不要泄漏
    private string AppKey = "******";
    //请求url
    private string ReqURL = "http://api.kdniao.cc/Ebusiness/EbusinessOrderHandle.aspx";

    protected void Page_Load(object sender, EventArgs e)
    {
    	string orderId=Request.QueryString["orderId"];
    	OrderInfo orderInfo = TradeHelper.GetOrderInfo(orderId);
    	if(orderInfo==null)
    	{
    		Response.Write("订单ID为空！");
    		return;
    	}
    	string nu=orderInfo.ShipOrderNumber;
    	string typeCom = orderInfo.ExpressCompanyName;
    	typeCom=ConvertShipperCode(typeCom);
    	if(string.IsNullOrEmpty(typeCom))
    	{
    		Response.Write("查询错误，请稍后重试!");
    		return;
    	}
    	string result=getOrderTracesByJson(typeCom,nu);
    	result=result.Substring(0,result.Length-2)+",\"ShipperName\":\""+orderInfo.ExpressCompanyName+"\"}";
    	Response.Write (result);
    }

    /// <summary>
    /// 将物流名称转为物流代码
    /// </summary>
    /// <param name="url">物流名称</param>
    /// <returns></returns>
    protected string ConvertShipperCode(string shipperName)
    {
    	if(string.IsNullOrEmpty(shipperName))
    		return "";
    	switch (shipperName){
			case "EMS"://ecshop后台中显示的快递公司名称
				return "ems";//快递公司代码
			case "中通速递":
				return "zto";
			case "7天连锁物流":
				return "7TLSWL";
			case "安捷快递":
				return "AJ";
			case "安能物流":
				return "ANE";
			case "安信达快递":
				return "AXD";
			case "巴伦支快递":
				return "BALUNZHI";
			case "百福东方":
				return "BFDF";
			case "宝凯物流":
				return "BKWL";
			case "北青小红帽":
				return "BQXHM";
			case "邦送物流":
				return "BSWL";
			case "百世物流":
				return "BTWL";
			case "CCES快递":
				return "CCES";
			case "城市100":
				return "CITY100";
			case "COE东方快递":
				return "COE";
			case "长沙创一":
				return "CSCY";
			case "传喜物流":
				return "CXWL";
			case "德邦":
				return "DBL";
			case "德创物流":
				return "DCWL";
			case "东红物流":
				return "DHWL";
			case "D速物流":
				return "DSWL";
			case "店通快递":
				return "DTKD";
			case "大田物流":
				return "DTWL";
			case "大洋物流快递":
				return "DYWL";
			case "快捷速递":
				return "FAST";
			case "飞豹快递":
				return "FBKD";
			case "FedEx联邦快递":
				return "FEDEX";
			case "飞狐快递":
				return "FHKD";
			case "飞康达":
				return "FKD";
			case "飞远配送":
				return "FYPS";
			case "凡宇速递":
				return "FYSD";
			case "广东邮政":
				return "GDEMS";
			case "冠达快递":
				return "GDKD";
			case "挂号信":
				return "GHX";
			case "港快速递":
				return "GKSD";
			case "共速达":
				return "GSD";
			case "广通速递":
				return "GTKD";
			case "国通快递":
				return "GTO";
			case "高铁速递":
				return "GTSD";
			case "河北建华":
				return "HBJH";
			case "汇丰物流":
				return "HFWL";
			case "华航快递":
				return "HHKD";
			case "天天快递":
				return "HHTT";
			case "韩润物流":
				return "HLKD";
			case "恒路物流":
				return "HLWL";
			case "黄马甲快递":
				return "HMJKD";
			case "海盟速递":
				return "HMSD";
			case "天地华宇":
				return "HOAU";
			case "华强物流":
				return "hq568";
			case "华企快运":
				return "HQKY";
			case "昊盛物流":
				return "HSWL";
			case "百世汇通":
				return "HTKY";
			case "户通物流":
				return "HTWL";
			case "华夏龙物流":
				return "HXLWL";
			case "好来运快递":
				return "HYLSD";
			case "京东快递":
				return "JD";
			case "京广速递":
				return "JGSD";
			case "九曳供应链":
				return "JIUYE";
			case "佳吉快运":
				return "JJKY";
			case "嘉里大通":
				return "JLDT";
			case "捷特快递":
				return "JTKD";
			case "急先达":
				return "JXD";
			case "晋越快递":
				return "JYKD";
			case "加运美":
				return "JYM";
			case "久易快递":
				return "JYSD";
			case "佳怡物流":
				return "JYWL";
			case "康力物流":
				return "KLWL";
			case "快淘快递":
				return "KTKD";
			case "快优达速递":
				return "KYDSD";
			case "跨越速递":
				return "KYWL";
			case "龙邦快递":
				return "LB";
			case "联邦快递":
				return "LBKD";
			case "蓝弧快递":
				return "LHKD";
			case "联昊通速递":
				return "LHT";
			case "乐捷递":
				return "LJD";
			case "立即送":
				return "LJS";
			case "民邦速递":
				return "MB";
			case "门对门":
				return "MDM";
			case "民航快递":
				return "MHKD";
			case "明亮物流":
				return "MLWL";
			case "闽盛快递":
				return "MSKD";
			case "能达速递":
				return "NEDA";
			case "南京晟邦物流":
				return "NJSBWL";
			case "平安达腾飞快递":
				return "PADTF";
			case "陪行物流":
				return "PXWL";
			case "全晨快递":
				return "QCKD";
			case "全峰快递":
				return "QFKD";
			case "全日通快递":
				return "QRT";
			case "如风达":
				return "RFD";
			case "日昱物流":
				return "RLWL";
			case "赛澳递":
				return "SAD";
			case "圣安物流":
				return "SAWL";
			case "盛邦物流":
				return "SBWL";
			case "山东海红":
				return "SDHH";
			case "上大物流":
				return "SDWL";
			case "顺丰快递":
				return "SF";
			case "盛丰物流":
				return "SFWL";
			case "上海林道货运":
				return "SHLDHY";
			case "盛辉物流":
				return "SHWL";
			case "穗佳物流":
				return "SJWL";
			case "速通物流":
				return "ST";
			case "申通快递":
				return "STO";
			case "三态速递":
				return "STSD";
			case "速尔快递":
				return "SURE";
			case "山西红马甲":
				return "SXHMJ";
			case "沈阳佳惠尔":
				return "SYJHE";
			case "世运快递":
				return "SYKD";
			case "通和天下":
				return "THTX";
			case "唐山申通":
				return "TSSTO";
			case "全一快递":
				return "UAPEX";
			case "优速快递":
				return "UC";
			case "万家物流":
				return "WJWL";
			case "微特派":
				return "WTP";
			case "万象物流":
				return "WXWL";
			case "新邦物流":
				return "XBWL";
			case "信丰快递":
				return "XFEX";
			case "香港邮政":
				return "XGYZ";
			case "祥龙运通":
				return "XLYT";
			case "希优特":
				return "XYT";
			case "源安达快递":
				return "YADEX";
			case "邮必佳":
				return "YBJ";
			case "远成物流":
				return "YCWL";
			case "韵达快递":
				return "YD";
			case "义达国际物流":
				return "YDH";
			case "越丰物流":
				return "YFEX";
			case "原飞航物流":
				return "YFHEX";
			case "亚风快递":
				return "YFSD";
			case "银捷速递":
				return "YJSD";
			case "亿领速运":
				return "YLSY";
			case "英脉物流":
				return "YMWL";
			case "亿顺航":
				return "YSH";
			case "音素快运":
				return "YSKY";
			case "易通达":
				return "YTD";
			case "一统飞鸿":
				return "YTFH";
			case "运通快递":
				return "YTKD";
			case "圆通速递":
				return "YTO";
			case "宇鑫物流":
				return "YXWL";
			case "邮政平邮/小包":
				return "YZPY";
			case "增益快递":
				return "ZENY";
			case "汇强快递":
				return "ZHQKD";
			case "宅急送":
				return "ZJS";
			case "芝麻开门":
				return "ZMKM";
			case "中睿速递":
				return "ZRSD";
			case "众通快递":
				return "ZTE";
			case "中铁快运":
				return "ZTKY";
			case "中铁物流":
				return "ZTWL";
			case "中天万运":
				return "ZTWY";
			case "中外运速递":
				return "ZWYSD";
			case "中邮物流":
				return "ZYWL";
			case "郑州建华":
				return "ZZJH";
			default:
				return  "";
		}
    }



    /// <summary>
    /// Json方式 查询订单物流轨迹
    /// </summary>
    ///<param name="shipperCode">物流公司编码</param>
    ///<param name="logisticCode">物流订单号</param>
    /// <returns></returns>
    public string getOrderTracesByJson(string shipperCode,string logisticCode)
    {
        string requestData = "{'OrderCode':'','ShipperCode':'"+shipperCode+"','LogisticCode':'"+logisticCode+"','SiteUrl':'"+Request.Url.Host+"','App':'hishop6.2'}";

        Dictionary<string, string> param = new Dictionary<string, string>();
        param.Add("RequestData", HttpUtility.UrlEncode(requestData, Encoding.UTF8));
        param.Add("EBusinessID", EBusinessID);
        param.Add("RequestType", "1002");
        string dataSign = encrypt(requestData, AppKey, "UTF-8");
        param.Add("DataSign", HttpUtility.UrlEncode(dataSign, Encoding.UTF8));
        param.Add("DataType", "2");
        string result = sendPost(ReqURL, param);
        return result;
    }

    /// <summary>
    /// XML方式 查询订单物流轨迹
    /// </summary>
    /// <returns></returns>
    public string getOrderTracesByXml()
    {
        string requestData = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>" +
                            "<Content>" +
                            "<OrderCode></OrderCode>" +
                            "<ShipperCode>SF</ShipperCode>" +
                            "<LogisticCode>589707398027</LogisticCode>" +
                            "</Content>";

        Dictionary<string, string> param = new Dictionary<string, string>();
        param.Add("RequestData", HttpUtility.UrlEncode(requestData, Encoding.UTF8));
        param.Add("EBusinessID", EBusinessID);
        param.Add("RequestType", "1002");
        string dataSign = encrypt(requestData, AppKey, "UTF-8");
        param.Add("DataSign", HttpUtility.UrlEncode(dataSign, Encoding.UTF8));
        param.Add("DataType", "1");

        string result = sendPost(ReqURL, param);

        //根据公司业务处理返回的信息......

        return result;
    }

    /// <summary>
    /// Post方式提交数据，返回网页的源代码
    /// </summary>
    /// <param name="url">发送请求的 URL</param>
    /// <param name="param">请求的参数集合</param>
    /// <returns>远程资源的响应结果</returns>
    private string sendPost(string url, Dictionary<string, string> param)
    {
        string result = "";
        StringBuilder postData = new StringBuilder();
        if (param != null && param.Count > 0)
        {
            foreach (var p in param)
            {
                if (postData.Length > 0)
                {
                    postData.Append("&");
                }
                postData.Append(p.Key);
                postData.Append("=");
                postData.Append(p.Value);
            }
        }
        byte[] byteData = Encoding.GetEncoding("UTF-8").GetBytes(postData.ToString());
        try
        {

            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);
            request.ContentType = "application/x-www-form-urlencoded";
            request.Referer = url;
            request.Accept = "*/*";
            request.Timeout = 30 * 1000;
            request.UserAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727; .NET CLR 3.0.04506.648; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)";
            request.Method = "POST";
            request.ContentLength = byteData.Length;
            Stream stream = request.GetRequestStream();
            stream.Write(byteData, 0, byteData.Length);
            stream.Flush();
            stream.Close();
            HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            Stream backStream = response.GetResponseStream();
            StreamReader sr = new StreamReader(backStream, Encoding.GetEncoding("UTF-8"));
            result = sr.ReadToEnd();
            sr.Close();
            backStream.Close();
            response.Close();
            request.Abort();
        }
        catch (Exception ex)
        {
            result = ex.Message;
        }
        return result;
    }

    ///<summary>
    ///电商Sign签名
    ///</summary>
    ///<param name="content">内容</param>
    ///<param name="keyValue">Appkey</param>
    ///<param name="charset">URL编码 </param>
    ///<returns>DataSign签名</returns>
    private string encrypt(String content, String keyValue, String charset)
    {
        if (keyValue != null)
        {
            return base64(MD5(content + keyValue, charset), charset);
        }
        return base64(MD5(content, charset), charset);
    }

    ///<summary>
    /// 字符串MD5加密
    ///</summary>
    ///<param name="str">要加密的字符串</param>
    ///<param name="charset">编码方式</param>
    ///<returns>密文</returns>
    private string MD5(string str, string charset)
    {
        byte[] buffer = System.Text.Encoding.GetEncoding(charset).GetBytes(str);
        try
        {
            System.Security.Cryptography.MD5CryptoServiceProvider check;
            check = new System.Security.Cryptography.MD5CryptoServiceProvider();
            byte[] somme = check.ComputeHash(buffer);
            string ret = "";
            foreach (byte a in somme)
            {
                if (a < 16)
                    ret += "0" + a.ToString("X");
                else
                    ret += a.ToString("X");
            }
            return ret.ToLower();
        }
        catch
        {
            throw;
        }
    }

    /// <summary>
    /// base64编码
    /// </summary>
    /// <param name="str">内容</param>
    /// <param name="charset">编码方式</param>
    /// <returns></returns>
    private string base64(String str, String charset)
    {
        return Convert.ToBase64String(System.Text.Encoding.GetEncoding(charset).GetBytes(str));
    }
}